/************************************************************************/
/*********************   PROGRAMA PRINCIPAL  ***************************/
/************************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "const.h"
#include "estruc.h"
#undef EXTERN
#define EXTERN
#include "glovar.h"

extern parser_teo(), parser_goal(), verlis(char *mensa, struct lista *ini);
extern oe(), fe(), resob_cla(), resob_sem();
extern struct lista *flat(struct lista* obj, struct lista **final);
extern ver_st();

/* Constantes para propiciar la traza o no de los calculos que se
efectuan durante la ejecucion del programa. */

#define NTRACE  0       /* No Trazar los calculos */
#define STRACE  1       /* Si Trazar los calculos */
int traceaux;

PRIVATE toma(int *opcion);
PRIVATE trazar();

main()
{    int opcion = 0;
     trace = NTRACE;
     while (opcion!=0xF)
      {
	printf("\t\tPROGRAMACION CON LOGICA ECUACIONAL");
	printf("\n\tTEORIA.");
	printf("\n\t.........................................................");
	printf("\n\t0 Introducir teoria");
	printf("\t\t1 Visualizar teoria\n");
	printf("\n\t2 Semantica operacional: O(E)");
	printf("\t3 Visualizar O(E)\n");
	printf("\n\t4 Semantica Punto Fijo: F(E)");
	printf("\t5 Visualizar F(E)\n");
	printf("\n\tOBJETIVOS.");
	printf("\n\t.........................................................");
	printf("\n\t6 Introducir objetivo");
	printf("\t\t7 Visualizar objetivo\n");
	printf("\n\t8 Resolucion del objetivo:");
	printf("\t9 Resolucion del objetivo:\n");
	printf("\t  Metodo Clasico");
	printf("\t\t  Metodo Semantico\n");
	printf("\n\t10 Aplanar el objetivo\n");
	printf("\n\t.........................................................");
	printf("\n\t11 Trazar Si / Trazar No");
	printf("\t12 Estadisticas");
	printf("\n\n\t.........................................................");
	printf("\n\tF FINALIZAR LA SESION\n");
	printf("\n\t\t\tElija opcion...");
	toma(&opcion);

	switch (opcion)
	   {
	     case 0: 	parser_teo(); break;
	     case 0x1:	verteo(); break;
	     case 0x2: 	oe(); break;
	     case 0x3: 	verlis("\n\nO(E): \n", oeini); break;
	     case 0x4: 	fe(); break;
	     case 0x5: 	verlis("\n\nF(E): \n", feini); break;
	     case 0x6: 	parser_goal(); break;
	     case 0x7: 	verlis("\n\nOBJETIVO: <=\n", goalini); break;
	     case 0x8: 	resob_cla(); break;
	     case 0x9: 	resob_sem(); break;
	     case 0x10: fgoalini=flat(goalini,&fgoalfin); 
			verlis("\nLista de ecuaciones FLAT: ",fgoalini);
			borralis(fgoalini);
			break;
	     case 0x11: trazar(); break;
	     case 0x12: ver_st(); break;
	     case 0xF: 	fclose(out); exit(0);
	   }
	printf("\n\n\t\tPulse RETURN para continuar..."); 
	getchar();
      }
}

/* Este procedimiento es necesario unicamente por las
peculiaridades de la funcion getchar() y la E/S con buffer de la
libreria estandar, lee en un buffer interno todos los caracteres
incluido el \n. */

PRIVATE toma(int *op)
{
  scanf("%x", op);
  while ( (((*op)<0) || ((*op)>0x9)) && ((*op)!=0x10) &&
		((*op)!=0x11) && ((*op)!=0x12) && ((*op)!=0xF) )
	scanf("%x", op);
  /* Lee el nueva linea. Ademas, si alguien mete mas caracteres como
  opcion solo tendra en cuenta el primer numero. */
  while(getchar() != '\n');

}


/* Pone, alternativamente, el valor de la variable global trace a trazar
o no trazar. */

PRIVATE trazar()
{
	if (trace) trace = NTRACE;
	else trace = STRACE;
}



