/************************* PROCEDIMIENTOS AUXILIARES ************************
* FICHERO proaux.h : Definicion de los prototipos de funcion; puntos de
* entrada del fichero proaux.c . 
*************************************************************************/

/*********************  GESTION DE LA MEMORIA  *********************/

extern memerror(), borraecu(struct arbol *ecu), borralis(struct lista *lisini),
    borrafun (struct funcs *simbini), borraocu(struct lista *ocuini),
    borrasub (struct subs *alfa), borrastat(struct stat *est),
    borraTinter(struct stat *est), borratocu (struct tocur *ocuini),
    borralisub(struct lisub *listasub);

extern struct arbol *copiecu (struct arbol *term),
		    *copiterm (struct arbol *term);
extern struct lista *copilis(struct lista *lis);
extern struct subs  *copisub(struct subs *sub);
extern struct stat *copistat(struct stat *est);

/***************************  VISUALIZACION **************************/

extern verterm(struct arbol *term), verteo(), verocu(char *mensa, struct lista *ini), 
    verecu1(struct arbol *ecu), verecu(struct arbol *ecu), 
    verlis(char *mensa, struct lista *ini), verunif(struct subs *alfa), 
    verestado(struct stat *estado);


/**************************   OCURRENCIAS   *****************************/

extern struct arbol *modifica (struct arbol *ecu, 
			struct arbol *viejo, struct arbol *nuevo);

extern struct lista *ocubas(struct arbol **ecu, struct lista **final);


/*************************   ESTANDARIZACION   **************************/

extern fresh(char *var);

extern struct arbol *estandar(struct arbol *ecu);


/**************** CALCULO DE ECUACIONES PLANAS ******************************

extern int esvar(struct arbol *term), 
      struct lista *flat(struct lista *obj, struct lista **final);


/*************** ESTADISTICAS Y CALCULOS DE EFICIENCIA ****************/

extern start_st(char metodo), stop_st(), ver_st();


/************************************************************************/

